;PIC16F627A 'traffic lamp' programja
;(c)Copyright 2014 Miklan Attila

	TITLE   "Kozlekedesi lampa vezerlo PIC16F627A"

	LIST    P=16F627A       ;f=ixm8m
	LIST	R=DECIMAL


	__CONFIG        _CP_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC & _LVP_OFF

	include "p16f627a.inc"
	include "multi.inc"	;foprogram valtozoi es konstansai
	include "wait.inc"	;beepulo modul valtozoi es konstansai
	include "serial.inc"	;beepulo modul valtozoi es konstansai
	include "feny.inc"	;beepulo modul valtozoi es konstansai


;Makrok ========================================================================
;Bitmasolas WREG file-regiszter es portbit kozott
COPYWREGBIT	MACRO	x,y,z
	 btfss	WREG,x
	 bcf	y,z
	 btfsc	WREG,x
	 bsf	y,z
	ENDM

;Vektorok ======================================================================
	org     0
	goto    START

;0-as szegmens rutin(ok) =======================================================

;Kimemetek allapotanak tablazatai

	include "tltableM.inc"


;Foprogram =====================================================================
START:
	clrf	STATUS			;set BANK0 for sure
	movlw   INIT_PORTA              ;PORTA inicializalas
	movwf   PORTA
	movlw   INIT_PORTB              ;PORTB inicializalas
	movwf   PORTB
	movlw	7			;16F84A kompatibilis uzemmod:
	movwf	CMCON			; komparatorok lekapcsolasa RAx-rol
	bsf	STATUS,RP0		;set BANK1
	movlw   B'00000111'             ;T0CS=CLKOUT, T0SE=lohigh, TMR0 PS=1/256
	movwf	OPTION_REG              ;4915200Hz -> 1228800Hz -> 4800Hz @ TMR0
	movlw   TRIS_PORTB              ;PORTB iranybeallitas
	movwf	TRISB
	movlw   TRIS_PORTA              ;PORTA iranybeallitas
	movwf	TRISA
	bcf	STATUS,RP0		;set BANK0 (default)
	movf	PORTA,W			;soros cim (0:MASTER, mas:SLAVE)
	xorlw	0ffh			;negaljuk az erteket
	andlw	0fh			;marad az also 4 bit
	movwf	MAIN_seraddr		;ez lesz a soros cimunk
	movlw	1			;szamlalok inditasa
	movwf	MAIN_cnt100ms		;utemezohoz
	movwf	MAIN_phasecnt		;fazisokhoz
	movwf	MAIN_blinkcnt		;villogashoz
	clrf	MAIN_phase		;fazis
	clrf	MAIN_outputM		;kimenetek allapota
	clrf	MAIN_blinkM		;villogas
	clrf	MAIN_outputS1
	clrf	MAIN_blinkS1
	clrf	MAIN_outputS2
	clrf	MAIN_blinkS2
	clrf	MAIN_outputS3
	clrf	MAIN_blinkS3

;soros vonali baud rate beallitasa (BRGH)
	bsf	STATUS,RP0		;set BANK1
	movlw	63			;4915200Hz / (64*(63+1)) -> 1200baud
	movwf	SPBRG
	bcf	STATUS,RP0		;set BANK0 (default)

;ugras a megfelelo init rutinra
	movf	MAIN_seraddr,W		;soros cim
	btfss	STATUS,Z		;'skip next' ha nulla (MASTER)
	goto	SLAVE_INIT		;ha nem nulla: ugrunk a SLAVE initre
MASTER_INIT:
	movlw	B'10000000'		;MASTER:soros fogadas tiltva (csak SPEN)
	movwf	RCSTA
	bsf	STATUS,RP0		; set BANK1
	movlw	B'00100000'		; soros adas enged. (TXEN=1, BRGH=0)
	movwf	TXSTA
	bcf	STATUS,RP0		; set BANK0 (default)
	goto	MAIN
SLAVE_INIT:
	movlw	B'10010000'		;SLAVE: soros fogadas eng. (SPEN, CREN)
	movwf	RCSTA
	bsf	STATUS,RP0		; set BANK1
	bsf	TRISB,RB1		; RB1/RX input
	bsf	TRISB,RB2		; RB2/TX input
	movlw	B'00000000'		; soros adas tiltva (TXEN=0, BRGH=0)
	movwf	TXSTA
	bcf	STATUS,RP0		; set BANK0 (default)
	goto	MAIN

;Fociklus ----------------------------------------------------------------------
MAIN:
;ugras a megfelelo foprogramra	
	movf	MAIN_seraddr,W		;soros cim
	btfss	STATUS,Z		;'skip next' ha nulla (MASTER)
	goto	SLAVE			;nem nulla: ugrunk a SLAVE foprogramra

;100ms utemezo (ketszer 50ms varakozassal) -> csak a MASTER-ben fut!
	movlw	T50MSRATE
	addwf	MAIN_cnt100ms,F		;50ms novekmeny hozzaadasa
; az elso 50ms a soros kuldes ideje miatt atugorva, reszletesen lasd a szovegben
;	movf	MAIN_cnt100ms,W		;eddig kell varakoznunk
;	call	WAIT4TMR		;varakozas TMR0 ertek eleresere
	movlw	T50MSRATE
	addwf	MAIN_cnt100ms,F		;50ms novekmeny hozzaadasa
	movf	MAIN_cnt100ms,W		;eddig kell varakoznunk
	call	WAIT4TMR		;varakozas TMR0 ertek eleresere

;MASTER foprogram: rendszeridozites es a SLAVE-ek vezerlese --------------------
MASTER:
	decfsz	MAIN_phasecnt,F		;fazis idotartam-szamlalojat csokkentjuk
	goto	MAIN_NONEWPHASE		;ugras, ha meg nem jart le a fazis
	incf	MAIN_phase,W		;kovetkezo fazisra lepunk (5 fazis van)
	xorlw	6			;limitalas: 6 eseten nullazodik
	btfss	STATUS,Z		;'skip next' ha nulla lett (marad nulla)
	xorlw	6			;visszaallitas, ha meg nem 6 volt
	movwf	MAIN_phase		; -- MASTER --
	call	TABLEACTIVE		;kimenetek allapota tablazatbol (MASTER)
	movwf	MAIN_outputM		;letaroljuk a munkavaltozoba
	movf	MAIN_phase,W		;fazis sorszama
	call	TABLEBLINK		;villogo kimenetek tablazatbol (MASTER)
	movwf	MAIN_blinkM		;letaroljuk a munkavaltozoba
	movlw	3			; -- SLAVE 1 --
	addwf	MAIN_phase,W		;(MASTER tablazat +3 eltolassal)
	call	TABLEACTIVE		;aktiv kimenetek SLAVE 1
	movwf	MAIN_outputS1
	movlw	3			;SLAVE1 / SLAVE3 offset
	addwf	MAIN_phase,W		;(MASTER tablazat +3 eltolassal)
	call	TABLEBLINK		;villogo kimenetek SLAVE 1
	movwf	MAIN_blinkS1
	movf	MAIN_phase,W		; -- SLAVE 2 --
	call	TABLEACTIVE		;aktiv kimenetek SLAVE 2
	movwf	MAIN_outputS2		;(MASTER-el azonos fazisban mukodik)
	movf	MAIN_phase,W
	call	TABLEBLINK		;villogo kimenetek SLAVE 2
	movwf	MAIN_blinkS2
	movlw	3			; -- SLAVE 3 --
	addwf	MAIN_phase,W		;(MASTER tablazat +3 eltolassal)
	call	TABLEACTIVE		;aktiv kimenetek SLAVE 3
	movwf	MAIN_outputS3
	movlw	3			;SLAVE1 / SLAVE3 offset
	addwf	MAIN_phase,W		;(MASTER tablazat +3 eltolassal)
	call	TABLEBLINK		;villogo kimenetek SLAVE 3
	movwf	MAIN_blinkS3
	movf	MAIN_phase,W            ; -- LENGTH --
	call	TABLELENGTH		;fazis idotartama tablazatbol
	movwf	MAIN_phasecnt		;letarolas a munkavaltozoba
MAIN_NONEWPHASE:
;villogasok kezelese
	decfsz	MAIN_blinkcnt,F		;500ms villogas szamlalo csokkentese
	goto	MAIN_NOBLINK		;ugrunk, ha meg nem jart le
	movlw	BLINKRATE		;szamlalo ujrainditasa fix ertekrol
	movwf	MAIN_blinkcnt
	movf	MAIN_blinkM,W		;WREG bit '1' ott ahol villog
	xorwf	MAIN_outputM,F		;kimenetek atallitasa ellentetesre
	movf	MAIN_blinkS1,W		;WREG bit '1' ott ahol villog
	xorwf	MAIN_outputS1,F		;kimenetek atallitasa ellentetesre
	movf	MAIN_blinkS2,W		;WREG bit '1' ott ahol villog
	xorwf	MAIN_outputS2,F		;kimenetek atallitasa ellentetesre
	movf	MAIN_blinkS3,W		;WREG bit '1' ott ahol villog
	xorwf	MAIN_outputS3,F		;kimenetek atallitasa ellentetesre
	call	FENYSOROMPO		;itt kezeljuk a fenysorompot is @500ms
	movwf	MAIN_outputS4		;a negyedik cimen levo SLAVE allapota
MAIN_NOBLINK:
;allapot kikuldese soros vonalon a SLAVE egysegek reszere
	clrf	MAIN_csadd		;ellenorzo osszeg torlese
	clrf	MAIN_csxor		;toroljuk a XOR osszeget is
	movlw	PKT_SYNC
	call	SERIAL_PUTCH		;SYNC kikuldese (csomag eleje)
	; adatok kikuldese eloszor (itt meg nem szamolunk ellenorzo osszeget)
	movf	MAIN_outputS1,W		;Slave1 allapota (keresztirany)
	call	SERIAL_PUTCH		;adat kikuldese a soros vonalon
	movf	MAIN_outputS2,W		;Slave2 allapota (MASTER iranya)
	call	SERIAL_PUTCH		;adat kikuldese a soros vonalon
	movf	MAIN_outputS3,W		;Slave3 allapota (keresztirany)
	call	SERIAL_PUTCH		;adat kikuldese a soros vonalon
	movf	MAIN_outputS4,W		;Slave4 allapota (fenysorompok)
	call	SERIAL_PUTCH		;adat kikuldese a soros vonalon
	; adatok kikuldese masodszor (itt szamoljuk az ellenorzo osszeget)
	movf	MAIN_outputS1,W		;Slave1 allapota
	call	PKT_SENDBYTE		;kikuldes ellenorzo osszeg szamitassal
	movf	MAIN_outputS2,W		;Slave2 allapota
	call	PKT_SENDBYTE		;kikuldes ellenorzo osszeg szamitassal
	movf	MAIN_outputS3,W		;Slave3 allapota
	call	PKT_SENDBYTE		;kikuldes ellenorzo osszeg szamitassal
	movf	MAIN_outputS4,W		;Slave4 allapota
	call	PKT_SENDBYTE		;kikuldes ellenorzo osszeg szamitassal
	movf	MAIN_csadd,W		;ADD ellenorzo osszeg
	call	SERIAL_PUTCH		;kikuldese
	movf	MAIN_csxor,W		;XOR ellenorzo osszeg
	call	SERIAL_PUTCH		;kikuldese

; allapot beallitasa a portokon
	movf	MAIN_outputM,W		;WREG elokeszitese a bitmasolas makrohoz
	movwf	WREG			;WREG elokeszitese bitmasolas makrohoz
;Tablazat hozzarendelese a hardware kimenetekhez (lasd Excel makrok es kapcsolasi rajzok)
; bit7 kiegeszito lampa   RB3
; bit6 p kozuti piros     RB6
; bit5 s kozuti sarga     RA4
; bit4 z kozuti zold      RB7
; bit3 p gyalogos piros   RB5
; bit2 z gyalogos zold    RB4
; bit1 p gyalogos-2 piros RB0
; bit0 z gyalogos-2 zold  RA3
	COPYWREGBIT 0,PORTA,3
	COPYWREGBIT 1,PORTB,0
	COPYWREGBIT 2,PORTB,4
	COPYWREGBIT 3,PORTB,5
	COPYWREGBIT 4,PORTB,7
	COPYWREGBIT 6,PORTB,6
	COPYWREGBIT 7,PORTB,3
	COPYWREGBIT 5,PORTA,4		;RA4 lassan valtozik, ezert utolso! (open drain, read-modify-write)

	goto     MAIN			;ezzel be is fejeztuk



;Slave foprogram: mukodes a soros vonalon erkezo adatok alapjan ----------------
SLAVE:
	movf	MAIN_rxpos,W		;itt tartunk a csomagban (Z set by movf)
	btfss	STATUS,Z		;'skip next' ha csomag eleje (Z=1)
	goto	SLAVE_GETPACKET		;ugrunk, ha mar nem
SLAVE_GETSYNC:
	call	SERIAL_GETCH		;adat fogadasa W-be is (var amig megjon)
	xorlw	PKT_SYNC		;osszehasonlitjuk SYNC ertekkel
	btfss	STATUS,Z                ;'skip next' ha SYNC jott (Z=1)
	goto	MAIN			;tovabb varunk, ha nem SYNC volt
SLAVE_SYNCOK:
	incf	MAIN_rxpos,F		;atlepunk a csomag fogadasara
SLAVE_GETPACKET:
	call	SERIAL_GETCH		;adat fogadasa W-be is (var amig megjon)
SLAVE_PROCPACKET:
	movf	MAIN_rxpos,W		;itt tartunk a csomagban
	addlw	MAIN_outputS1-1		;itt kezdodik a tomb, -1 az rxpos miatt
	movwf	FSR			;indirekt cimzes lesz
	movf	SERIAL_data,W		;soros adat vissza W-be
	movwf	INDF			;letaroljuk
	incf	MAIN_rxpos,F		;tovabblepunk a csomagban
	movf	MAIN_rxpos,W		;pozicio a csomag vegehez
	xorlw	11			;itt van a csomag vege
	btfss	STATUS,Z		;'skip next' ha elertuk (Z=1)
	goto	MAIN			;tovabb varunk, ha meg nem a vege

SLAVE_PROCMSG:
	clrf	MAIN_rxpos		;kovetkezo csomagot varjuk majd
	;Ellenorizzuk a beerkezett adatokat es kijelezzuk ha hibatlan
	;(most az elso csomag van az S1..S4 valtozokban)
	call	CALCCS			;S1-S4 ellenorzese, vissza Z=1 ha jo
	btfsc	STATUS,Z		;'skip next' ha nem volt jo
	goto	SLAVE_OUTPUT		;S1-S4 helyes, ugras a kijelzesre
	;(masodik csomag bemasolasa S1..S4 valtozokba)
	movf	MAIN_outputS1B,W
	movwf	MAIN_outputS1
	movf	MAIN_outputS2B,W
	movwf	MAIN_outputS2
	movf	MAIN_outputS3B,W
	movwf	MAIN_outputS3
	movf	MAIN_outputS4B,W
	movwf	MAIN_outputS4
	call	CALCCS			;S1-S4 ellenorzese, vissza Z=1 ha jo
	btfsc	STATUS,Z		;'skip next' ha nem volt jo
	goto	SLAVE_OUTPUT		;S1-S4 helyes, ugras a kijelzesre
	goto	MAIN			;mindket csomag rossz, nincs kijelzes!

;kimenetek beallitasa a soros cimnek megfelelo adat szerint
SLAVE_OUTPUT:
	movf	MAIN_seraddr,W		;ez a soros cimunk
	movwf	MAIN_temp		;atmeneti taroloba, itt csokkentjuk majd
	movf	MAIN_outputS1,W		;1. soros cimhez tartozo adat W-be
	decf	MAIN_temp,F		;soros cim csokkentese
	btfsc	STATUS,Z		;'skip next' ha nem 0 (a soros cim nem 1)
	goto	SLAVE_SETOUTPUT		;ugrunk a kimenetek beallitasara
	movf	MAIN_outputS2,W		;2. soros cimhez tartozo adat W-be
	decf	MAIN_temp,F		;soros cim csokkentese
	btfsc	STATUS,Z		;'skip next' ha nem 0 (a soros cim nem 2)
	goto	SLAVE_SETOUTPUT		;ugrunk a kimenetek beallitasara
	movf	MAIN_outputS3,W		;3. soros cimhez tartozo adat W-be
	decf	MAIN_temp,F		;soros cim csokkentese
	btfss	STATUS,Z		;'skip next' ha 0 (a soros cim 3)
	goto	SLAVE_SETOUTPUT2	;ugras fenysorompo kimenetek allitasara

SLAVE_SETOUTPUT:
	movwf	WREG			;WREG elokeszitese bitmasolas makrohoz;
;Tablazat hozzarendelese a hardware kimenetekhez (lasd Excel makrok es kapcsolasi rajzok)
; bit7 kiegeszito lampa   RB3
; bit6 p kozuti piros     RB6
; bit5 s kozuti sarga     RA4
; bit4 z kozuti zold      RB7
; bit3 p gyalogos piros   RB5
; bit2 z gyalogos zold    RB4
; bit1 p gyalogos-2 piros RB0
; bit0 z gyalogos-2 zold  RA3
	COPYWREGBIT 0,PORTA,3
	COPYWREGBIT 1,PORTB,0
	COPYWREGBIT 2,PORTB,4
	COPYWREGBIT 3,PORTB,5
	COPYWREGBIT 4,PORTB,7
	COPYWREGBIT 6,PORTB,6
	COPYWREGBIT 7,PORTB,3
	COPYWREGBIT 5,PORTA,4		;RA4 lassan valtozik, ezert utolso! (open drain, read-modify-write)
	goto     SLAVE_END		;szepen fejezzuk be


SLAVE_SETOUTPUT2:
	movf	MAIN_outputS4,W		;4.soros cim: fenysorompo allapot
	movwf	WREG			;WREG elokeszitese bitmasolas makrohoz
;Tablazat hozzarendelese a hardware kimenetekhez (lasd feny.inc makrok es kapcsolasi rajzok)
; bit0 feher   RB0
; bit1 piros1  RB5
; bit2 piros2  RB4
	COPYWREGBIT 0,PORTB,0
	COPYWREGBIT 1,PORTB,5
	COPYWREGBIT 2,PORTB,4

SLAVE_END:
	goto     MAIN


;Szubrutinok ===================================================================

;S1-S4 adatok ellenorzese ADD es XOR osszeg alapjan, Z=1 ha jo
CALCCS:
	clrf	MAIN_csaddcalc		;itt kepezzuk az ellenorzo osszegeket
	clrf	MAIN_csxorcalc
	movf	MAIN_outputS1,W		;fogadott ertek
	addwf	MAIN_csaddcalc,F	;ADD ellenorzo osszeg kepzese
	xorwf	MAIN_csxorcalc,F	;XOR ellenorzo osszeg kepzese
	movf	MAIN_outputS2,W		;...tovabb az osszes byte-ra...
	addwf	MAIN_csaddcalc,F
	xorwf	MAIN_csxorcalc,F
	movf	MAIN_outputS3,W
	addwf	MAIN_csaddcalc,F
	xorwf	MAIN_csxorcalc,F
	movf	MAIN_outputS4,W
	addwf	MAIN_csaddcalc,F
	xorwf	MAIN_csxorcalc,F
	movf	MAIN_csaddcalc,W	;szamolt ADD ertek
	xorwf	MAIN_csadd,W		;fogadott ertek (Z=1 ha egyezik)
	btfss	STATUS,Z		;'skip next' ha egyezik
	goto	CALCCS_END		;visszateres, ha nem egyezik (Z=0)
	movf	MAIN_csxorcalc,W	;szamolt XOR ertek
	xorwf	MAIN_csxor,W		;fogadott ertek (Z=1 ha egyezik)
CALCCS_END:
	return				;visszateres a kialakult Z flaggel

;Soros karakter kikuldese az ellenorzo osszegek frissitesevel ------------------
PKT_SENDBYTE:
	addwf	MAIN_csadd,F	;ADD ellenorzo osszeg frissitese
	xorwf	MAIN_csxor,F	;XOR ellenorzo osszeg frissitese
	call	SERIAL_PUTCH
	retlw 0


;Beepulo modulok ===============================================================
	include "wait.asm"	;keslelteto rutinok
	include "serial.asm"	;soros vonalat kezelo rutinok
	include "feny.asm"	;fenysorompo allapotait szamolo modul

	end
