;PIC16F627A 'traffic lamp' programja
;(c)Copyright 2014 Miklan Attila

	TITLE   "Kozlekedesi lampa vezerlo PIC16F627A"

	LIST    P=16F627A       ;f=ixm8m
	LIST	R=DECIMAL


	__CONFIG        _CP_OFF & _PWRTE_ON & _WDT_OFF & _HS_OSC & _LVP_OFF

	include "p16f627a.inc"
	include "single.inc"	;foprogram valtozoi es konstansai
	include "wait.inc"	;beepulo modul valtozoi es konstansai
	include "feny.inc"	;beepulo modul valtozoi es konstansai


;Makrok ========================================================================
;Bitmasolas WREG file-regiszter es portbit kozott
COPYWREGBIT	MACRO	x,y,z
	 btfss	WREG,x
	 bcf	y,z
	 btfsc	WREG,x
	 bsf	y,z
	ENDM

;Vektorok ======================================================================
	org     0
	goto    START

;0-as szegmens rutin(ok) =======================================================

;Kimemetek allapotanak tablazatai

	include "tltableS.inc"


;Foprogram =====================================================================
START:
	clrf	STATUS			;set BANK0 for sure
	movlw   INIT_PORTA              ;PORTA inicializalas
	movwf   PORTA
	movlw   INIT_PORTB              ;PORTB inicializalas
	movwf   PORTB
	movlw	7			;16F84A kompatibilis uzemmod:
	movwf	CMCON			; komparatorok lekapcsolasa RAx-rol
	bsf	STATUS,RP0		;set BANK1
	movlw   B'00000111'             ;T0CS=CLKOUT, T0SE=lohigh, TMR0 PS=1/256
	movwf	OPTION_REG              ;4915200Hz -> 1228800Hz -> 4800Hz @ TMR0
	movlw   TRIS_PORTB              ;PORTB iranybeallitas
	movwf	TRISB
	movlw   TRIS_PORTA              ;PORTA iranybeallitas
	movwf	TRISA
	bcf	STATUS,RP0		;set BANK0 (default)
	movlw	1			;szamlalok inditasa
	movwf	MAIN_cnt100ms		;utemezohoz
	movwf	MAIN_phasecnt		;fazisokhoz
	movwf	MAIN_blinkcnt		;villogashoz
	clrf	MAIN_phase		;fazis
	clrf	MAIN_outputA		;kimenetek allapota
	clrf	MAIN_blinkA		;villogas
	clrf	MAIN_outputB
	clrf	MAIN_blinkB
	clrf	MAIN_outputF

;Fociklus ----------------------------------------------------------------------
MAIN:
;100ms utemezo (ketszer 50ms varakozassal)
	movlw	T50MSRATE
	addwf	MAIN_cnt100ms,F		;50ms novekmeny hozzaadasa
	movf	MAIN_cnt100ms,W		;eddig kell varakoznunk
	call	WAIT4TMR		;varakozas TMR0 ertek eleresere
	movlw	T50MSRATE
	addwf	MAIN_cnt100ms,F		;50ms novekmeny hozzaadasa
	movf	MAIN_cnt100ms,W		;eddig kell varakoznunk
	call	WAIT4TMR		;varakozas TMR0 ertek eleresere

	decfsz	MAIN_phasecnt,F		;fazis idejenek szamlalasa
	goto	MAIN_NONEWPHASE		;ugras, ha nem jart le
	incf	MAIN_phase,W		;kovetkezo fazis sorszama
	xorlw	6			;limitalas: 6 eseten nullazzuk
	btfss	STATUS,Z		;'skip next' ha nulla (marad nulla)
	xorlw	6			;visszaallitas
	movwf	MAIN_phase		; -- PORTA --
	call	TABLEACTIVEA		;aktiv kimenetek PORTA
	movwf	MAIN_outputA
	movf	MAIN_phase,W
	call	TABLEBLINKA		;villogo kimenetek PORTA
	movwf	MAIN_blinkA
	movf	MAIN_phase,W		; -- PORTB --
	call	TABLEACTIVEB		;aktiv kimenetek PORTB
	movwf	MAIN_outputB
	movf	MAIN_phase,W
	call	TABLEBLINKB		;villogo kimenetek PORTB
	movwf	MAIN_blinkB

	movf	MAIN_phase,W            ; -- LENGTH --
	call	TABLELENGTH		;fazis idotartama
	movwf	MAIN_phasecnt
MAIN_NONEWPHASE:
;villogasok kezelese
	decfsz	MAIN_blinkcnt,F		;500ms villogas szamlalo leptetese
	goto	MAIN_NOBLINK		;ugrik, ha nem jart le
	movlw	BLINKRATE		;szamlalo ujrainditasa
	movwf	MAIN_blinkcnt
	movf	MAIN_blinkA,W		;villogasok WREG-be
	xorwf	MAIN_outputA,F		;kimenetek atallitasa
	movf	MAIN_blinkB,W		;villogasok WREG-be
	xorwf	MAIN_outputB,F		;kimenetek atallitasa
	call	FENYSOROMPO		;itt kezeljuk a fenysorompot is @500ms
	movwf	MAIN_outputF		;ez a fenysorompo kimenete
MAIN_NOBLINK:
	movf	MAIN_outputA,W		;WREG elokeszitese bitmasolas makrohoz
	movwf	WREG
;Tablazat hozzarendelese a hardware kimenetekhez (lasd Excel makrok es kapcsolasi rajzok)
; Bitek jelentese egy byte-on belul, portA:
; bit7 kiegeszito lampa
; bit6 p kozuti piros      RB5
; bit5 s kozuti sarga      RB4
; bit4 z kozuti zold       RB3
; bit3 p gyalogos piros    RA4
; bit2 z gyalogos zold     RA3
; bit1 p gyalogos-2 piros  RA2
; bit0 z gyalogos-2 zold   RA1
	COPYWREGBIT 0,PORTA,1
	COPYWREGBIT 1,PORTA,2
	COPYWREGBIT 2,PORTA,3
	COPYWREGBIT 4,PORTB,3
	COPYWREGBIT 5,PORTB,4
	COPYWREGBIT 6,PORTB,5
	COPYWREGBIT 3,PORTA,4		;RA4 lassan valtozik, ezert utolso! (open drain, read-modify-write)
	movf	MAIN_outputB,W		;WREG elokeszitese bitmasolas makrohoz
	movwf	WREG
; Bitek jelentese egy byte-on belul, portB:
; bit7
; bit6 p kozuti piros      RB2
; bit5 s kozuti sarga      RB1
; bit4 z kozuti zold       RB0
; bit3
; bit2
; bit1
; bit0
	COPYWREGBIT 6,PORTB,2
	COPYWREGBIT 5,PORTB,1
	COPYWREGBIT 4,PORTB,0
	movf	MAIN_outputF,W		;WREG elokeszitese bitmasolas makrohoz
	movwf	WREG
; Bitek jelentese egy byte-on belul, fenysorompo:
; bit2 fenysorompo voros2  RB7
; bit1 fenysorompo voros1  RB6
; bit0 fenysorompo feher   RA0
	COPYWREGBIT 0,PORTA,0
	COPYWREGBIT 1,PORTB,6
	COPYWREGBIT 2,PORTB,7
	goto     MAIN


;Szubrutinok ===================================================================

;Beepulo modulok ===============================================================
	include "wait.asm"	;keslelteto rutinok
	include "feny.asm"	;fenysorompo allapotait szamolo modul


	end
